com.jogamp.opengl.util.awt

## Class AWTGLReadBufferUtil

- java.lang.Object
- - com.jogamp.opengl.util.GLReadBufferUtil
  - - com.jogamp.opengl.util.awt.AWTGLReadBufferUtil

-     public class AWTGLReadBufferUtil
      extends GLReadBufferUtil

  `GLReadBufferUtil` specialization allowing to read out a frambuffer to an AWT BufferedImage utilizing `AWTPixelBufferProviderInt` for further AWT processing.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AWTGLReadBufferUtil(GLProfile glp, boolean alpha)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `AWTGLPixelBuffer` | `getAWTGLPixelBuffer()` Returns the `AWTGLPixelBuffer`, as filled by previous call to `GLReadBufferUtil.readPixels(GL, int, int, int, int, boolean)`.
    `BufferedImage` | `readPixelsToBufferedImage(GL gl, boolean awtOrientation)` Read the drawable's pixels to TextureData and Texture, if requested at construction, and returns an aligned `BufferedImage`.
    `BufferedImage` | `readPixelsToBufferedImage(GL gl, int inX, int inY, int inWidth, int inHeight, boolean awtOrientation)` Read the drawable's pixels to TextureData and Texture, if requested at construction, and returns an aligned `BufferedImage`.

    - ### Methods inherited from class com.jogamp.opengl.util.GLReadBufferUtil

      `dispose, getGLPixelStorageModes, getPixelBuffer, getPixelBufferProvider, getTexture, getTextureData, hasAlpha, isValid, readPixels, readPixels, rewindPixelBuffer, write`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AWTGLReadBufferUtil

          public AWTGLReadBufferUtil(GLProfile glp,
                             boolean alpha)

      Parameters:
        `alpha` -

  - ### Method Detail

    - #### getAWTGLPixelBuffer

          public AWTGLPixelBuffer getAWTGLPixelBuffer()

      Returns the `AWTGLPixelBuffer`, as filled by previous call to `GLReadBufferUtil.readPixels(GL, int, int, int, int, boolean)`.

    - #### readPixelsToBufferedImage

          public BufferedImage readPixelsToBufferedImage(GL gl,
                                                boolean awtOrientation)

      Read the drawable's pixels to TextureData and Texture, if requested at construction, and returns an aligned `BufferedImage`.
      Parameters:
        `gl` - the current GL context object. It's read drawable is being used as the pixel source.
        `awtOrientation` - flips the data vertically if `true`. The context's drawable `GLDrawable.isGLOriented()` state is taken into account. Vertical flipping is propagated to TextureData and handled in a efficient manner there (TextureCoordinates and TextureIO writer).
      See Also:
        `AWTGLReadBufferUtil(GLProfile, boolean)`

    - #### readPixelsToBufferedImage

          public BufferedImage readPixelsToBufferedImage(GL gl,
                                                int inX,
                                                int inY,
                                                int inWidth,
                                                int inHeight,
                                                boolean awtOrientation)

      Read the drawable's pixels to TextureData and Texture, if requested at construction, and returns an aligned `BufferedImage`.
      Parameters:
        `gl` - the current GL context object. It's read drawable is being used as the pixel source.
        `inX` - readPixel x offset
        `inY` - readPixel y offset
        `inWidth` - optional readPixel width value, used if [1 .. drawable.width], otherwise using drawable.width
        `inHeight` - optional readPixel height, used if [1 .. drawable.height], otherwise using drawable.height
        `awtOrientation` - flips the data vertically if `true`. The context's drawable `GLDrawable.isGLOriented()` state is taken into account. Vertical flipping is propagated to TextureData and handled in a efficient manner there (TextureCoordinates and TextureIO writer).
      See Also:
        `AWTGLReadBufferUtil(GLProfile, boolean)`

Copyright 2010 JogAmp Community.